#include <iostream>

using namespace std;

int main()
{
    int n, k, resenje = 0;
    cin >> n >> k;
    int m[n][n];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> m[i][j];
    bool a[k] = {false}, provera;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(!a[m[i][j] - 1]) {
                const int y = j;
                int x = i;
                while(j < n) {
                    if(m[i][j + 1] == m[i][y])
                        j++;
                    else
                        break;
                }
                while(x < n) {
                    if(m[x + 1][j] == m[i][y])
                        x++;
                    else
                        break;
                }
                a[m[i][y] - 1] = true;
                provera = false;
                if(((x - i) != (j - y)) || (x == i)) {
                    for(int q = 0; q < n; q++) {
                        for(int w = 0; w < n; w++) {
                            if(((q < i || q > x || w < y || w > j) && (m[q][w] == m[i][y])) || ((q >= i && q <= x && w >= y && w <= j) && (m[q][w] != m[i][y]))){
                                provera = true;
                                break;
                            }
                        }
                        if(provera)
                            break;
                    }
                    if(!provera) {
                        resenje++;
                    }
                }
            }
        }
    }
    cout << resenje;
    return 0;
}